clc
clear

X = [0.5, 1.0, 2.0, 3.0, 3.5]';
Y = [10.0, 5.0, 4.5, 1.2, 2.2]';

% Passo ai logaritmi naturali per y:
% Y1 = log(Y) = log(a) + b*X
Y1 = log(Y);

% Calcolo il polinomio interpolatore per Y1
POL = polyfit(X,Y1,1);

% Ricalcolo il valore di Y1 nei punti di appoggio
Y1_calc  = polyval(POL,X);

% Calcolo il valore di Y corrispondente ai punti di appoggio
Y_calc = exp(Y1_calc);

% Calcolo il valore di Y in corrispondenza a 2.5
Y1_calc_25 = polyval(POL,2.5);
Y_calc_25 = exp(Y1_calc_25);

% Calcolo somma scarti verticali
somma = sum((Y_calc-Y).^2);

% Stampa dei risultati
fprintf('Valore di Y stimato in X:\n')
fprintf('  %15.6e',Y_calc)
fprintf('\n\n')
fprintf('Valore di Y stimato in 2.5:\n')
fprintf('  %15.6e',Y_calc_25)
fprintf('\n\n')
fprintf('Somma degli scarti verticali:\n')
fprintf('  %15.6e',somma)
fprintf('\n\n')

plot(X,Y,' ro',X,Y_calc,'-b^',2.5,Y_calc_25,' g+')
